#ifndef _THING_H
#define  _THING_H

#define SYS_THGL    0xb8

typedef struct thing_link
{
    struct  thing_link *nxtth;
    long    usage;
    void    *frfre;
    void    *frzap;
    void    *thing;
    void    *use;
    void    *free;
    void    *ffree;
    void    *remov;
    unsigned char    nshar;
    unsigned char    check;
    long    verid;
    short   namelen;
} THG_LINK, *PTHG_LINK;

typedef struct
{
    int flag;
    int type;
} THG_HEAD, *PTHG_HEAD;

#define THH_FLAG        0x54484725         /* THG% */         

#define THT_THING       -1
#define THT_UTIL        0
#define THT_EXEC        1
#define THT_DATA        2
#define THT_EXTN        3
#define THT_EXTS        4

#define THT__LST        0x1000000

int sms_lthg (PTHG_LINK);
int sms_fthg (char *, int, int, int *, void *, void **);
int sms_uthg (char *, int, int, int *, void **, int *, void **);
int sms_rthg (char *);
int sms_zthg (char *);
int sms_nthg (char *, PTHG_LINK *);
int sms_nthu (char *, PTHG_LINK *, int *);
void thg_free (void *);
void * thg_malloc (int, int);

#endif
