*
* Support.s 
* 
* A public domain implementation of support routines for the 
* HOTStuff library
*
* (c) Jonathan Hudson 1993
*

.globl  getthg
.globl	thg_malloc
.globl	malloc0
.globl  __StackA1
.globl  __A1len

sms.achp	equ	$18
sms.info        equ     $00

sys_thgl 	equ    	$b8

th_thing 	equ    	$10

thh_type 	equ    	$04
thh_entr 	equ    	$08
err.nimp 	equ    	-19

.text

* Researched (i.e. plagerised) this bit from TTs libqptr button stuff
* looks for the Hotkey thing, returns its vector in a0


getthg:
	move.l	d2,-(sp)
        moveq   #sms.info,d0            ; get system variables
        trap    #1
        move.l  sys_thgl(a0),d2         ; this is the Thing list
        beq     thg_nf                  ; empty list, very bad!
        move.l  d2,a0
thg_lp:
        move.l  (a0),d2                 ; get next list entry
        beq     thg_found               ; end of list? Here should be THING!
        move.l  d2,a0                   ; next link
        bra     thg_lp
thg_found:
        move.l  th_thing(a0),a0         ; get start of Thing
        move.l  thh_type(a0),d2         ; is it our special THING?
        addq.l  #1,d2
        bne     thg_nf                  ; sorry, it isnt
        move.l  thh_entr(a0),a0       	; this is the vector we look for
	bra	thg_rts
thg_nf:
        moveq   #err.nimp,d0            ; no thing
thg_rts:
	move.l	(sp)+,d2
	tst.l	d0
        rts

*
*  Malloc some memory for job
*
malloc0:
        moveq   #0,d0
        bra     getmem
thg_malloc:
	move.l	8(sp),d0
getmem:
	move.l	4(sp),d1
	movem.l	d2-d3/a2-a3,-(sp)
	move.l	d0,d2
    	moveq	#sms.achp,d0
	trap	#1
	tst.l	d0
	beq	m1
	moveq	#0,d0
	bra	m2
m1:
	move.l	a0,d0
m2:
	movem.l	(sp)+,d2-d3/a2-a3
	rts

*
*	Creates a QDOS string descriptor on bottom of the stack from the
*	'C' string in A1 and the QDOS string in A1. Assumes it fits.
*	Munges A0, D0, D2
*

__StackA1:

        bsr	__A1len
	move.l	a1,a0
	move.l	_SPBASE,a1
        move.l  d2,d0
        add.l   #3,d0
        andi.l  #$fffe,d0
        add.l   d0,a1
        move.l  a1,-(sp)   
        move.w  d2,(a1)+            	; size
        subq.l  #1,d2               	; less one for dbra
l3:     move.b  (a0)+,(a1)+         	; move text
        dbra    d2,l3               	; loop
	move.l	(sp)+,a1
	rts
*
*	d2 = __A1len(a1)
*

__A1len:
        moveq   #0,d2
l1:     tst.b   0(a1,d2.w)          	; got a nul ?
        beq     l2                  	; yes, skip
        addq.w  #1,d2               	; no, inc counter
        bra     l1                  	; and loop
l2:
	rts

	end
